//
// C Implementation: eel_util
//
// Description: 
//
//
// Author: Ryan Cunningham <rcunning@cs.ucla.edu>, (C) 2004
//
// Copyright: See COPYING file that comes with this distribution
//
//

// a mess of headers here, likely can remove some
#include <sys/types.h>
#include <tree.h>
#include <queue.h>
#include <sys/time.h>
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <err.h>
#include <assert.h>

#include "eel.h"
#include "eel_util.h"
#include "eel_select.h"
#include "eel_poll.h"
#include "eel_epoll.h"

// --------------------------------------------------------
// compare_time_values - rb tree compare function
// --------------------------------------------------------
static int compare_time_values(struct eel_event *e0, struct eel_event *e1)
{
  // simply compare the timer values
  if (TIMERCMP(&e0->timer, &e1->timer, <)) {
    return -1;
  } else if (TIMERCMP(&e0->timer, &e1->timer, >)) {
    return 1;
  }
  // they are the same, sort by pointer value
  if (e0 < e1) {
    return -1;
  } else if (e0 > e1) {
    return 1;
  }
  // they are the same pointer!
  return 0;
}

// generate the rb tree functions
RB_GENERATE(event_rb_tree, eel_event, timer_rb_entry, compare_time_values);

// --------------------------------------------------------
// get_preferred_eel_operators - return the 'best' 
// *eel_operators available as determined by the pecking
// order with this functions
// --------------------------------------------------------
struct eel_operators *get_preferred_eel_operators()
{
  struct eel_operators *preferred_eel_operators = NULL;
  struct eel_operators *temp_eel_operators = NULL;
  // event mechnism pecking order
  // select as the base
  if ((temp_eel_operators = get_select_eel_operators())) {
    preferred_eel_operators = temp_eel_operators;
  }
  // poll trumps select
  if ((temp_eel_operators = get_poll_eel_operators())) {
    preferred_eel_operators = temp_eel_operators;
  }
  // epoll trumps poll
  if ((temp_eel_operators = get_epoll_eel_operators())) {
    preferred_eel_operators = temp_eel_operators;
  }

  return preferred_eel_operators;
}

